<?php
/*
    checks what DEF variables are present in cdef and returns them as array
*/

function cdef_components($cdef_string) {
	preg_match_all('/([a-z]{1})/',$cdef_string,$match);
	/*
	$tmp_match:
	[0] => a
	[3] => b
	*/
	return array_unique($match[0]);
}

/*
    converts hexadecimal color representation to it's decimal form
    in style "255,0,128"
*/
function hex2dec($hex) {
    $res=explode("\n",trim(chunk_split($hex,2)));
    foreach ($res as $id => $hex) 
	$res[$id] = hexdec($hex);
    $res = implode(",",$res);
    return $res;
}

/*
    clean titles from garbage (like %&$#) before passing to the java-applet 
*/
function clean($str) {
    //return preg_replace('/\W+/',' ',$str); //sometimes in titles apear "%" sign and java-applet is unable to handle it as string
    
    //rrdtool output encloses titles with ""
    $str = str_replace('\"','^^',$str);
    $str = str_replace('"','',$str);
    $str = str_replace('^^','"',$str);
    $str = str_replace(',',';',$str);
    return $str;
}

/*
    checks string against non-aplhanumeric characters
*/
function check_string($sid) {
    if ( preg_match('/[^\w+]/i', $sid) )
	return false;
    else 
	return true;
}

/*
    saves output to the file (for debugging purposes)
*/
function write_file($file,$path,$content,$type) {
    if ($handle = fopen($path."/".$file,$type)) {
	$stat = fwrite($handle,$content);
	fclose($handle);
	if ($stat) return true;
    }
    return false;
}

/*
    fully encodes string in base64
*/
function encode_base64($string) {
    $string = base64_encode($string);
    $string = str_replace(array('+','/','='),array('-','_','.'),$string);
    return $string;
}

/*
    fully decodes base64 string
*/
function decode_base64($string) {
    $string = str_replace(array('-','_','.'),array('+','/','='),$string);
    $string = base64_decode($string);
    return $string;
}

/* 
    searches for substring in array key
*/
function assoc($arr2look,$key) {
    foreach ($arr2look as $string)
        if (stristr($string,$key)) return $string;
    return false;
}

/*
    outputs an error and terminates (currently only if color definitions are wrong - noticeable on some older cacti versions)
*/
function err_to_browser($err) {
    echo "
    <HTML>
     <HEAD>
	<TITLE>ZOND ERROR</TITLE>
    </HEAD>
    <BODY bgcolor = #F9F9F9>
	<TABLE width=100% height=100%>
	    <TR><TD align=middle>
		<strong><font color=red>ERROR:$err</font></strong>
	    </TD></TR>
	</TABLE>
    </BODY>
    </HTML>
    ";
    
    die();
}

/*
    some definitions here to avoid code doubling in scripts
*/
$zond_config_params = array (
                            'width',
                            'height',
			    'autosize',
			    'scaletype',
			    'charttype',
                            'refresh',
                            'font_name',
                            'font_size',
                            'axis_pos',
                            'axis_rot',
                            'indicator',
                            'values',
			    'legtype',
                            'contour',
                            'majhorz',
                            'majvert',
                            'minvert',
                            'minhorz',                
                            'step',                   
                            'trans',
			    'user',
			    'pass',
			    'security'
            );

$fonts = array (
                "Arial",                              
                "Arial Rounded MT Bold",              
                "Bitstream Vera Sans Mono",           
                "Century Gothic",                     
                "Courier",                            
                "Courier New",                        
                "Lucida Sans",                        
                "MS Reference Sans Serif",
                "Tahoma"
                );

$php_bin_path = read_config_option("path_php_binary");

$PROTO = 'http://';
$PROTO = isset($_SERVER['SERVER_PROTOCOL']) && strstr($_SERVER['SERVER_PROTOCOL'],'HTTPS') ? 'https://' : 'http://' ;

?>
